using System.Collections;
using System.Collections.Generic;
using UnityEngine;

class Piece {
    
    public int[] data;
    public int cx, cy, w, h;
    
    public Piece( int ship_piece_index, int ship_piece_orientation ) {
        
        data = new int[ 16 ];
        
        cx = 0;
        cy = 0;
        w = 0;
        h = 0;
        
        switch( ship_piece_index ) {
            
            case 0: {
                
                switch ( ship_piece_orientation ) {
                    
                    case 0: {
                        cx = 0; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            1, 0, 0, 0,
                            1, 0, 0, 0,
                            1, 1, 0, 0
                        };
                    } break;
                    
                    case 1: {
                        cx = 2; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            0, 0, 1, 0,
                            1, 1, 1, 0
                        };
                    } break;
                    
                    case 2: {
                        cx = 1; cy = 2;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            1, 1, 0, 0,
                            0, 1, 0, 0,
                            0, 1, 0, 0
                        };
                    } break;
                    
                    case 3: {
                        cx = 0; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 1, 0,
                            1, 0, 0, 0
                        };
                    } break;
                }
                
            } break;
            
            case 1: {
                
                switch ( ship_piece_orientation ) {
                    
                    case 0: {
                        cx = 1; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 1, 0, 0,
                            0, 1, 0, 0,
                            1, 1, 0, 0
                        };
                    } break;
                    
                    case 1: {
                        cx = 2; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 1, 0,
                            0, 0, 1, 0
                        };
                    } break;
                    
                    case 2: {
                        cx = 0; cy = 2;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            1, 1, 0, 0,
                            1, 0, 0, 0,
                            1, 0, 0, 0
                        };
                    } break;
                    
                    case 3: {
                        cx = 0; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 0, 0, 0,
                            1, 1, 1, 0
                        };
                    } break;
                };
                
            } break;
            
            case 2: {
                
                switch ( ship_piece_orientation ) {
                    
                    case 0: {
                        cx = 1; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 0, 0,
                            0, 1, 1, 0
                        };
                    } break;
                    
                    case 1: {
                        cx = 1; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 1, 0, 0,
                            1, 1, 0, 0,
                            1, 0, 0, 0
                        };
                    } break;
                    
                    case 2: {
                        cx = 1; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 0, 0,
                            0, 1, 1, 0
                        };
                    } break;
                    
                    case 3: {
                        cx = 0; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 1, 0, 0,
                            1, 1, 0, 0,
                            1, 0, 0, 0
                        };
                    } break;
                }
            } break;
            
            case 3: {
                
                switch ( ship_piece_orientation ) {
                    
                    case 0: {
                        cx = 1; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            0, 1, 1, 0,
                            1, 1, 0, 0
                        };
                    } break;
                    
                    case 1: {
                        cx = 1; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            1, 0, 0, 0,
                            1, 1, 0, 0,
                            0, 1, 0, 0
                        };
                    } break;
                    
                    case 2: {
                        cx = 1; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            0, 1, 1, 0,
                            1, 1, 0, 0
                        };
                    } break;
                    
                    case 3: {
                        cx = 0; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            1, 0, 0, 0,
                            1, 1, 0, 0,
                            0, 1, 0, 0
                        };
                    } break;
                }
            } break;
            
            case 4: {
                
                switch ( ship_piece_orientation ) {
                    
                    case 0: {
                        cx = 0; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 0, 0,
                            1, 1, 0, 0
                        };
                    } break;
                    
                    case 1: {
                        cx = 1; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 0, 0,
                            1, 1, 0, 0
                        };
                    } break;
                    
                    case 2: {
                        cx = 1; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 0, 0,
                            1, 1, 0, 0
                        };
                    } break;
                    
                    case 3: {
                        cx = 0; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 0, 0,
                            1, 1, 0, 0
                        };
                    } break;
                };
            } break;
            
            case 5: {
                
                switch ( ship_piece_orientation ) {
                    
                    case 0: {
                        cx = 1; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 1, 1
                        };
                    } break;
                    
                    case 1: {
                        cx = 0; cy = 1;
                        data = new int[ 16 ] {
                            1, 0, 0, 0,
                            1, 0, 0, 0,
                            1, 0, 0, 0,
                            1, 0, 0, 0
                        };
                    } break;
                    
                    case 2: {
                        cx = 2; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 1, 1
                        };
                    } break;
                    
                    case 3: {
                        cx = 0; cy = 2;
                        data = new int[ 16 ] {
                            1, 0, 0, 0,
                            1, 0, 0, 0,
                            1, 0, 0, 0,
                            1, 0, 0, 0
                        };
                    } break;
                };
            } break;
            
            case 6: {
                
                switch ( ship_piece_orientation ) {
                    
                    case 0: {
                        cx = 1; cy = 0;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            0, 1, 0, 0,
                            1, 1, 1, 0
                        };
                    } break;
                    
                    case 1: {
                        cx = 1; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 1, 0, 0,
                            1, 1, 0, 0,
                            0, 1, 0, 0
                        };
                    } break;
                    
                    case 2: {
                        cx = 1; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            0, 0, 0, 0,
                            1, 1, 1, 0,
                            0, 1, 0, 0
                        };
                    } break;
                    
                    case 3: {
                        cx = 0; cy = 1;
                        data = new int[ 16 ] {
                            0, 0, 0, 0,
                            1, 0, 0, 0,
                            1, 1, 0, 0,
                            1, 0, 0, 0
                        };
                    } break;
                };
            } break;
        }
        
        for ( int y1 = 0, y2 = 3; y1 < 2; y1++, y2-- ) {
            for ( int x = 0; x < 4; x++ ) {
                
                int temp = data[ y1 * 4 + x ];
                data[ y1 * 4 + x ] = data[ y2 * 4 + x ];
                data[ y2 * 4 + x ] = temp;
            }
        }
        
        for ( int y = 0; y < 4; y++ ) {
            for ( int x = 0; x < 4; x++ ) {
                
                if ( data[ y * 4 + x ] != 0 ) {
                    
                    if ( x >= w ) {
                        w = x + 1;
                    }
                    
                    if ( y >= h ) {
                        h = y + 1;
                    }
                }
            }
        }
        
        Debug.Assert( cx < w );
        Debug.Assert( cy < h );
    }
};
